package com.wissamfawaz;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;

public class Main {
	private static Scanner fileScan;
	private static HashMap<String, Long> wordsCount = new HashMap<String, Long>();

	public static void main(String[] args) throws IOException {
		fileScan = new Scanner(new File("in.txt"));

		computeFreqs();
		displayOutput();
		fileScan.close();
	}

	private static void computeFreqs() {
		String word;
		long count;
		while(fileScan.hasNext()) {
			word = fileScan.next();
			word = word.replaceAll("\\p{P}", "").toLowerCase();
			if(wordsCount.containsKey(word)) {
				count = wordsCount.get(word);
				wordsCount.put(word, count+1);
			} else {
				wordsCount.put(word, 1L);
			}
		}
		
	}
	
	private static void displayOutput() {
		Set<String> keySet = wordsCount.keySet();
		TreeSet<String> sortedKeySet = new TreeSet<String>(keySet);
		String firstWord = sortedKeySet.first();
		char runningChar = firstWord.charAt(0);
		char currentChar;
		System.out.printf("%C: %n", runningChar);
		for(String word : sortedKeySet) {
			currentChar = word.charAt(0);
			if(currentChar != runningChar) {
				System.out.printf("%C: %n", currentChar);
				runningChar = currentChar;
			}
			System.out.printf("%13s: %d%n", word, wordsCount.get(word));
		}
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}
