package com.wissamfawaz;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Map;
import java.util.TreeMap;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

public class Main {

	public static void main(String[] args) throws IOException {
		Path path = Paths.get("in.txt");
		
		Pattern pattern = Pattern.compile("\\s+");
		
		Map<String, Long> wordsCount = 
				Files.lines(path)
					 .map(line -> line.replaceAll("(?!')\\p{P}", ""))
					 .flatMap(line -> pattern.splitAsStream(line))
					 .collect(Collectors.groupingBy(String::toLowerCase, 
							 TreeMap::new, Collectors.counting()));
		//wordsCount.forEach((word, freq) -> System.out.printf("%13s: %d%n", word, freq));
		
		wordsCount.entrySet()
				  .stream()
				  .collect(Collectors.groupingBy(entry -> entry.getKey().charAt(0), 
						  TreeMap::new, Collectors.toList()))
				  .forEach((initial, list) -> {
					  System.out.printf("%C: %n", initial);
					  list.stream().forEach(entry -> System.out.printf("%13s: %d%n", entry.getKey(), entry.getValue()));
				  });
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		

	}

}
