package com.wissamfawaz;

import java.security.SecureRandom;
import java.time.Duration;
import java.time.Instant;
import java.util.function.Function;
import java.util.stream.Collectors;

public class Main {

	public static void main(String[] args) {
		/*
		 * int[] frequencies = new int[7]; Random rnd = new Random(); for(int i=1; i <=
		 * 6_000_000; i++) { frequencies[rnd.nextInt(6) + 1]++; }
		 * 
		 * for(int i=1; i<=6; i++) { System.out.print(i + "\t");
		 * System.out.println(frequencies[i]); }
		 */

		SecureRandom rnd = new SecureRandom();
		System.out.printf("%-8s%s%n", "Face", "Frequency");
		Instant start = Instant.now();
		rnd.ints(6_000_000, 1, 7)
		   .boxed()
		   .collect(Collectors.groupingBy(Function.identity(), Collectors.counting()))
		   .forEach((face, freq) -> System.out.printf("%-8d%d%n", face, freq));
		Instant end = Instant.now();
		System.out.printf("%d ms%n", Duration.between(start, end).toMillis());
		
	}

}
